/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package in.barc.iitb.cfdvs.SPLANE.models.parser;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 
 * @author Narwane
 */
public class TraceabilityParser extends Parser {

	private Map<String, List<List<String>>> traProvidesMap;
	private Map<String, String> traProvidesFormula;
	private String fileName;
	private boolean provide;

	private boolean require;

	public TraceabilityParser(String fileName) {
		this.fileName = fileName;
		this.traProvidesMap = new HashMap();
		this.traProvidesFormula = new HashMap<String, String>();
		this.provide = false;
		this.require = false;
	}

	@Override
	public Map parse() {
		readFile();
		return traProvidesMap;
	}

	private void readFile() {
		try {
			FileReader fstream = new FileReader(fileName);
			BufferedReader in = new BufferedReader(fstream);
			String line = null;
			while ((line = in.readLine()) != null) {
				if (line != null && !line.trim().equals("")) {
					parseLine(line);
				}
			}
		} catch (Exception e) {
			System.err.println("Error: " + e);
			// e.printStackTrace();
		}
	}

	public Map<String, List<List<String>>> getTraProvidesMap() {
		return traProvidesMap;
	}

	public void setTraProvidesMap(Map<String, List<List<String>>> traProvidesMap) {
		this.traProvidesMap = traProvidesMap;
	}

	public Map<String, String> getTraProvidesFormula() {
		return traProvidesFormula;
	}

	public void setTraProvidesFormula(Map<String, String> traProvidesFormula) {
		this.traProvidesFormula = traProvidesFormula;
	}

	private void parseLine(String line) throws Exception {
		String[] parseLineArr = line.split("=>");
		String lhs = parseLineArr[0].trim();
		String rhs = parseLineArr[1].trim();
		rhs = rhs.substring(0, rhs.length() - 1);
		rhs = rhs.trim();
		rhs = rhs.substring(1,rhs.length()-1);
		String[] rhsArr = rhs.split(",");
		List<List<String>> componentSetList = new ArrayList();
		for (int i = 0; i < rhsArr.length; i++) {
			String[] rhsSub = rhsArr[i].split(" ");
			List<String> subList = new ArrayList();
			for (int j = 0; j < rhsSub.length; j++) {
				if (rhsSub[j] != null && !rhsSub[j].equals("")) {
					String temp = rhsSub[j].trim();
					if (temp != null && !"".equals(temp)
							&& '{' == temp.charAt(0)) {
						temp = temp.substring(1);
					}
					if (temp != null && !"".equals(temp)
							&& '}' == temp.charAt(temp.length() - 1)) {
						temp = temp.substring(0, temp.length() - 1);
					}
					if (temp != null && !"".equals(temp.trim())) {
						subList.add(temp);
					}
				}
			}
			componentSetList.add(subList);
		}
		traProvidesMap.put(lhs.trim(), componentSetList);
	}

}
