package in.barc.iitb.cfdvs.SPLANE.Reasoner;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import es.us.isa.FAMA.Reasoner.Reasoner;
import es.us.isa.FAMA.models.featureModel.Cardinality;
import es.us.isa.FAMA.models.featureModel.GenericFeature;
import es.us.isa.FAMA.models.featureModel.GenericRelation;

public abstract class SplaneModelReasoner extends Reasoner {
		protected boolean turn;
		protected int numVar;
		abstract public void reset();
		abstract public void addFeature(GenericFeature feature);
		
		abstract public void addRoot(GenericFeature feature);
		abstract public void addMandatory(GenericRelation rel,GenericFeature child, GenericFeature parent);
		abstract public void addOptional(GenericRelation rel,GenericFeature child, GenericFeature parent);
		abstract public void addCardinality(GenericRelation rel,GenericFeature child, GenericFeature parent,Iterator<Cardinality> cardinalities);
		abstract public void addSet(GenericRelation rel,GenericFeature parent, Collection<GenericFeature> children,Collection<Cardinality> cardinalities);
		abstract public void addExcludes(GenericRelation rel,GenericFeature origin, GenericFeature destination);
		abstract public void addRequires(GenericRelation rel,GenericFeature origin, GenericFeature destination);
		abstract public String generateComponentConstraints();
		abstract public String generateFeatureConstraints();
		abstract public String generateTraceabilityFormula();
		public boolean isTurn() {
			return turn;
		}
		public int getNumVar() {
			return numVar;
		}
		public void setNumVar(int numVar) {
			this.numVar = numVar;
		}
		public void setTurn(boolean turn) {
			this.turn = turn;
		}
		abstract public void addTraceability(Map<String, List<List<String>>> tm2);
		
	}