package in.barc.iitb.cfdvs.NonSolverReasoner.questions;

import in.barc.iitb.cfdvs.NonSolverReasoner.INonSolverQuestion;
import in.barc.iitb.cfdvs.NonSolverReasoner.NonSolverQuestion;
import in.barc.iitb.cfdvs.NonSolverReasoner.NonSolverResult;
import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;

import java.util.Iterator;
import java.util.Map;

public class CompleteTraceabilityQuestion extends NonSolverQuestion implements
		INonSolverQuestion {

	private String resultDump;

	public CompleteTraceabilityQuestion() {
		questionId = QBFFormulaConstants.FORMULA_NAME_COMPLETE_TRACEABILITY;
	}

	@Override
	public NonSolverResult ask(QSATReasoner reasoner) {
		NonSolverResult nonSolverResult = new NonSolverResult();
		Iterator<Map.Entry<String, String>> entries = reasoner.getFeaturesMap()
				.entrySet().iterator();
		entries = reasoner.getFeaturesMap().entrySet().iterator();
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = entries.next();
			String str = reasoner.getTraceability().get(entry.getValue());
			if (str == null || (str != null && "".equals(str))) {
				resultDump = "The feature " + entry.getKey()
						+ " is not implemented.";
				nonSolverResult.setResultDump(resultDump);
				nonSolverResult.setResultFlag(false);
				nonSolverResult.setField(entry.getKey());
				return nonSolverResult;
			}
		}
		resultDump = "Traceability is complete.";
		nonSolverResult.setResultDump(resultDump);
		nonSolverResult.setResultFlag(true);
		nonSolverResult.setField("");
		return nonSolverResult;
	}
}
