package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.ICommonQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;

public class CommonQuestion extends QSATQuestion implements ICommonQuestion {

	String commonEntity = null;
	public CommonQuestion(String common){
		questionId = QBFFormulaConstants.FORMULA_NAME_COMMON;
		commonEntity = common;
	}

	@Override
	public void generateQBFFormula(QSATReasoner reasoner) throws QBFFormulaGenerationException{

		String commonEntitySH = reasoner.getFeaturesMap().get(commonEntity);
		if(commonEntitySH == null || "".equals(commonEntitySH)){
			commonEntitySH = reasoner.getComponentsMap().get(commonEntity);
		}
		
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_COMMON + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_FORALL + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			entries = reasoner.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ( !(");
			out.append(reasoner.getComponentConstraints() + " & " + reasoner.getFeatureConstraints() + " & (");
			entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append("( !" + entry.getValue() + " | "
						+ reasoner.getTraceability().get(entry.getValue()) + " )");
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append(")) | " + commonEntitySH + " )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}
}
