package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.ICriticalQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;

public class CriticalQuestion extends QSATQuestion implements ICriticalQuestion {

	private String featureName;
	private String criticalComponent;

	public CriticalQuestion(String feature, String critical) {
		questionId = QBFFormulaConstants.FORMULA_NAME_CRITICAL;
		featureName = feature;
		criticalComponent = critical;
	}

	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_CRITICAL + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner
					.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] (");
			out.append(reasoner.getComponentConstraints());
			out.append(" & ("+ reasoner.getComponentsMap().get(criticalComponent)+" )");
			out.append(" & "+ reasoner.getTraceability().get(
					reasoner.getFeaturesMap().get(featureName)));
			out.append(" )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}
}
