package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.IDeadQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;


public class DeadQuestion extends QSATQuestion implements IDeadQuestion{

	String deadEntity = null;
	public DeadQuestion(String dead){
		questionId = QBFFormulaConstants.FORMULA_NAME_DEAD;
		deadEntity = dead;
	}

	@Override
	public void generateQBFFormula(QSATReasoner reasoner) throws QBFFormulaGenerationException{

		String deadEntitySH = reasoner.getFeaturesMap().get(deadEntity);
		if(deadEntitySH == null || "".equals(deadEntitySH)){
			deadEntitySH = reasoner.getComponentsMap().get(deadEntity);
		}
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_DEAD + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_FORALL+ "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			entries = reasoner.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ( !(");
			out.append(reasoner.getComponentConstraints()+ " & "+reasoner.getFeatureConstraints()+ " & (");
			entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append("( !"+entry.getValue() + " | "+ reasoner.getTraceability().get(reasoner.getFeaturesMap().get(entry.getKey())) +" )");
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}			
			out.append(")) | !"+deadEntitySH+" )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}
}
