package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.IExistentiallyExplicitQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;

public class ExistentiallyExplicitQuestion extends QSATQuestion implements
		IExistentiallyExplicitQuestion {

	private Map<String, Boolean> specificationMap;
	
	public ExistentiallyExplicitQuestion(Map<String, Boolean> spec){
		specificationMap = spec;
	}

	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_EXISTENTIALLY_EXPLICITE
							+ ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getComponentsMap().entrySet()
					.iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getKey() + " ");
			}
			out.append("] ( " + reasoner.getComponentConstraints() + " & (");
			Iterator<Map.Entry<String, Boolean>> entriesSpec = specificationMap
					.entrySet().iterator();
			while (entries.hasNext()) {
				out.append("(");
				Map.Entry<String, Boolean> entry = entriesSpec.next();
				out.append("( !"
						+ (entry.getValue().booleanValue() ? "1" : "0") + " | "
						+ reasoner.getTraceability().get(entry.getKey()) + ") & ");
				out.append("(" + (entry.getValue().booleanValue() ? "1" : "0")
						+ " | !" + reasoner.getTraceability().get(entry.getKey()) + "))");
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append("))");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}

}
