package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.IImplementsQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ImplementsQuestion extends QSATQuestion implements
		IImplementsQuestion {

	private List<String> implementation;
	private String featureName;

	public ImplementsQuestion(List<String> implConf, String featureName) {
		questionId = QBFFormulaConstants.FORMULA_NAME_IMPLEMENTATION;
		implementation = implConf;
		this.featureName = featureName;
	}

	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			List<String> specification = new ArrayList<String>();
			specification.add(featureName);
			validComponents(implementation, reasoner.getComponentsMap());
			validFeatures(specification, reasoner.getFeaturesMap());
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_IMPLEMENTATION + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner
					.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] (");
			entries = reasoner.getComponentsMap().entrySet().iterator();
			out.append("( ");
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				String component = entry.getKey();
				if (implementation.contains(component))
					out.append(entry.getValue());
				else
					out.append("!" + entry.getValue());
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append(" ) & ( "
					+ reasoner.getTraceability().get(
							reasoner.getFeaturesMap().get(featureName)));
			out.append(" ) )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}

}
