package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.ILiveQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;


public class LiveQuestion extends QSATQuestion implements ILiveQuestion {

	String liveEntity = null;
	public LiveQuestion(String live){
		questionId = QBFFormulaConstants.FORMULA_NAME_LIVE;
		liveEntity = live;
	}

	@Override
	public void generateQBFFormula(QSATReasoner reasoner) throws QBFFormulaGenerationException{

		String liveEntitySH = reasoner.getFeaturesMap().get(liveEntity);
		if(liveEntitySH == null || "".equals(liveEntitySH)){
			liveEntitySH = reasoner.getComponentsMap().get(liveEntity);
		}
		
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_LIVE + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getFeaturesMap().entrySet()
					.iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			entries = reasoner.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ( (");
			out.append(reasoner.getComponentConstraints() + " & " + reasoner.getFeatureConstraints() + " & (");
			entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append("( !" + entry.getValue() + " | "
						+ reasoner.getTraceability().get(reasoner.getFeaturesMap().get(entry.getKey())) + " )");
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append(")) & " + liveEntitySH + " )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}
}
