package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.ISoundnessQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;


public class SoundnessQuestion extends QSATQuestion implements ISoundnessQuestion{

	public SoundnessQuestion(){
		questionId = QBFFormulaConstants.FORMULA_NAME_SOUNDNESS;
	}
	
	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_SOUNDNESS + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_FORALL + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getComponentsMap().entrySet()
					.iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ( !");
			out.append(reasoner.getComponentConstraints() + "  | (");
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ( " + reasoner.getFeatureConstraints() + " & (");
			entries = reasoner.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append("( !" + entry.getValue() + " | "
						+ reasoner.getTraceability().get(reasoner.getFeaturesMap().get(entry.getKey())) + " )");
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append("))))");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ImplementsQuestion.class.toString());
		}
	}
}
