package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.ICommonQuestion;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.IValidModelQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Map;

public class ValidFeatureModelQuestion extends QSATQuestion implements IValidModelQuestion {
	public ValidFeatureModelQuestion() {
		questionId = QBFFormulaConstants.FORMULA_NAME_VALID_FEATURE_MODEL;
	}

	@Override
	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_VALID_FEATURE_MODEL + ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner
					.getFeaturesMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] ");
			out.append(reasoner.getFeatureConstraints());
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ValidFeatureModelQuestion.class.toString());
		}
	}
}
