package in.barc.iitb.cfdvs.QSATReasoner.questions;

import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATException.QBFFormulaGenerationException;
import in.barc.iitb.cfdvs.QSATReasoner.QSATQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.SPLANE.questionInterfaces.IValidImplementationQuestion;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ValidImplementationQuestion extends QSATQuestion implements
		IValidImplementationQuestion {
	
	private List<String> implementation;
	public ValidImplementationQuestion(List<String> implConf) {
		questionId = QBFFormulaConstants.FORMULA_NAME_VALID_IMPLEMENTATION;
		implementation = implConf;
	}

	@Override
	public void generateQBFFormula(QSATReasoner reasoner)
			throws QBFFormulaGenerationException {
		try {
			FileWriter fstream = new FileWriter(prepath+
					QBFFormulaConstants.FORMULA_NAME_VALID_IMPLEMENTATION
							+ ".qbf");
			BufferedWriter out = new BufferedWriter(fstream);
			out.append(QBFFormulaConstants.QUANTIFIER_EXISTS + "[ ");
			Iterator<Map.Entry<String, String>> entries = reasoner.getComponentsMap().entrySet()
					.iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				out.append(entry.getValue() + " ");
			}
			out.append("] (");
			entries = reasoner.getComponentsMap().entrySet().iterator();
			out.append("( ");
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				String component = entry.getKey();
				if (implementation.contains(component))
					out.append(entry.getValue());
				else
					out.append("!" + entry.getValue());
				if (entries.hasNext()) {
					out.append(" & ");
				}
			}
			out.append(" ) & " + reasoner.getComponentConstraints());
			out.append(" )");
			out.close();
		} catch (Exception e) {
			throw new QBFFormulaGenerationException(e.getMessage(),
					ValidImplementationQuestion.class.toString());
		}
	}
}
