import in.barc.iitb.cfdvs.NonSolverReasoner.NonSolverReasoner;
import in.barc.iitb.cfdvs.NonSolverReasoner.NonSolverResult;
import in.barc.iitb.cfdvs.NonSolverReasoner.questions.CompleteTraceabilityQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.QSATReasoner.QSATResult;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CommonQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CompletenessQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CoversQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CriticalQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.DeadQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ImplementsQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.IntersectionQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.LiveQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.NotCriticalQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.RealizesQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.SoundnessQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.UnionQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.UniqueImplementationQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidComponentModelQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidFeatureModelQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidImplementationQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidModelQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidSpecificationQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.VoidProductModelQuestion;
import in.barc.iitb.cfdvs.SPLANE.models.parser.TraceabilityParser;
import in.barc.iitb.cfdvs.SPLANEModel.transformations.SplaneModelTransform;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import asg.cliche.Command;
import asg.cliche.Param;
import asg.cliche.ShellFactory;
import es.us.isa.FAMA.models.FAMAfeatureModel.fileformats.FMPlainTextReader;
import es.us.isa.FAMA.models.variabilityModel.TraceabilityModel;
import es.us.isa.FAMA.models.variabilityModel.VariabilityModel;

public class mainShell {

	TraceabilityModel tracemod = null;
	VariabilityModel featuremod = null;
	VariabilityModel componentmod = null;
	public static final String ANSI_RED = "\u001B[31m";
	public static final String ANSI_GREEN = "\u001B[32m";
	public static final String ANSI_BLACK = "\u001B[30m";
	public static final String ANSI_RESET = "\u001B[0m";

	@Command
	public String loadFeatureModel(String path) {

		FMPlainTextReader reader = new FMPlainTextReader();
		try {
			featuremod = reader.parseFile(path);
		} catch (Exception e) {
			return ANSI_RED + "The path you provided might be wrong."
					+ ANSI_BLACK + "\n";
		}
		return ANSI_GREEN + "Feature Model loaded successfully." + ANSI_BLACK
				+ "\n";
	}

	@Command
	public String loadComponenteModel(String path) {
		FMPlainTextReader reader = new FMPlainTextReader();
		try {
			componentmod = reader.parseFile(path);
		} catch (Exception e) {
			return ANSI_RED + "The path you provided might be wrong."
					+ ANSI_BLACK + "\n";
		}
		return ANSI_GREEN + "Component Model loaded successfully." + ANSI_BLACK
				+ "\n";
	}

	@Command
	public String loadtraceFile(String path) {
		TraceabilityParser trace = new TraceabilityParser(path);
		trace.parse();
		tracemod = new TraceabilityModel();
		tracemod.setTraceabilityOrgMap(trace.getTraProvidesMap());
		return ANSI_GREEN + "Traceability Model loaded successfully."
				+ ANSI_BLACK + "\n";

	}

	@Command
	public String validFeatureModel() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		ValidFeatureModelQuestion q = new ValidFeatureModelQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Feature Model is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Feature Model is INVALID.\n" + ANSI_BLACK;
	}

	@Command
	public String validComponentModel() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		ValidComponentModelQuestion q = new ValidComponentModelQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Component Model is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Component Model is INVALID.\n" + ANSI_BLACK;
	}

	@Command
	public String validModel() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		ValidModelQuestion q = new ValidModelQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "The SPL Model is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The SPL Model is INVALID.\n" + ANSI_BLACK;
	}

	@Command
	public String voidmodel() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		VoidProductModelQuestion q = new VoidProductModelQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "The SPL Model is NOT VOID.\n" + ANSI_BLACK;
		return ANSI_RED + "The SPL Model is VOID.\n" + ANSI_BLACK;
	}

	@Command
	public String validSpecification(
			@Param(name = "numbers", description = "add the names, the last one is going to be used as a feature.") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		for (String str : input) {
			boolean found = validInput(str, reasoner.getFeaturesMap());
			if (!found)
				return ANSI_RED + "Invalid element: " + str
						+ "\nInput is case sensitive.\n" + ANSI_BLACK;
			firstL.add(str);
		}
		ValidSpecificationQuestion q = new ValidSpecificationQuestion(firstL);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		System.out.println("Specification:" + firstL);
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Specification is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Specification is NOT VALID.\n" + ANSI_BLACK;
	}

	@Command
	public String validSpecification() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		System.out.println("Select Features in Specification(Yy/Nn):");
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		Iterator<Map.Entry<String, String>> entries = reasoner.getFeaturesMap()
				.entrySet().iterator();
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = entries.next();
			System.out.print(entry.getKey() + " :");
			String ch = null;
			try {
				ch = br.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (ch != null && (ch.equals("Y") || ch.equals("y")))
				firstL.add(entry.getKey());
		}
		ValidSpecificationQuestion q = new ValidSpecificationQuestion(firstL);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		System.out.println("Specification:" + firstL);
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Specification is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Specification is NOT VALID.\n" + ANSI_BLACK;
	}

	@Command
	public String validImplementation(
			@Param(name = "numbers", description = "add the names, the last one is going to be used as a implementation.") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		for (String str : input) {
			boolean found = validInput(str, reasoner.getComponentsMap());
			if (!found)
				return ANSI_RED + "Invalid element: " + str
						+ "\nInput is case sensitive.\n" + ANSI_BLACK;
			firstL.add(str);
		}
		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		System.out.println("Implementation:" + firstL);
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Implementation is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Implementation is NOT VALID.\n" + ANSI_BLACK;
	}

	@Command
	public String validImplementation() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		System.out.println("Select Components in Implementation(Yy/Nn):");
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		Iterator<Map.Entry<String, String>> entries = reasoner
				.getComponentsMap().entrySet().iterator();
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = entries.next();
			System.out.print(entry.getKey() + " :");
			String ch = null;
			try {
				ch = br.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (ch != null && (ch.equals("Y") || ch.equals("y")))
				firstL.add(entry.getKey());
		}
		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		System.out.println("Implementation:" + firstL);
		if (ask.isResultFlag())
			return ANSI_GREEN + "The Implementation is VALID.\n" + ANSI_BLACK;
		return ANSI_RED + "The Implementation is NOT VALID.\n" + ANSI_BLACK;
	}

	@Command
	public String completeTraceability() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		CompleteTraceabilityQuestion q = new CompleteTraceabilityQuestion();
		NonSolverReasoner nonSolverReasoner = new NonSolverReasoner();
		long startTime = System.currentTimeMillis();
		NonSolverResult nonSolverResult = nonSolverReasoner
				.execute(q, reasoner);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time:" + (stopTime - startTime));
		if (nonSolverResult.isResultFlag())
			return ANSI_GREEN + "Traceability Relation is Complete\n.\n"
					+ ANSI_BLACK;
		return ANSI_RED
				+ "Traceability is incomplete."
				+ nonSolverResult.getField()
				+ "\nTraceability should be complete, or other operations will give invalid result\nRemove above feature or add traceability for it\n"
				+ ANSI_BLACK;
	}

	@Command
	public String implement(
			@Param(name = "numbers", description = "add the implications, a comma and the feature") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		List<String> secondL = new ArrayList<String>();
		boolean first = true;
		for (String str : input) {
			if (first) {
				if (str.equals(",")) {
					first = false;
				} else {
					boolean found = validInput(str, reasoner.getComponentsMap());
					if (!found)
						return ANSI_RED + "Invalid element: " + str
								+ "\nInput is case sensitive.\n" + ANSI_BLACK;
					firstL.add(str);
				}
			} else {
				boolean found = validInput(str, reasoner.getFeaturesMap());
				if (!found)
					return ANSI_RED + "Invalid element: " + str
							+ "\nInput is case sensitive.\n" + ANSI_BLACK;
				secondL.add(str);
			}
		}
		if (secondL.size() == 0) {
			return ANSI_RED + "Too few parameter, feature missing.\n"
					+ ANSI_BLACK;
		} else if (secondL.size() > 1) {
			return ANSI_RED
					+ "Too many parameter, Multiple features specified.\n"
					+ ANSI_BLACK;
		}

		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		QSATResult ask = (QSATResult) reasoner.ask(q);
		if (!ask.isResultFlag())
			return ANSI_RED + firstL + "\nThe Implementation is NOT VALID.\n"
					+ ANSI_BLACK;
		ImplementsQuestion iq = new ImplementsQuestion(firstL, secondL.get(0));
		long startTime = System.currentTimeMillis();
		ask = (QSATResult) reasoner.ask(iq);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + firstL + " IMPLEMENTS " + secondL.get(0)
					+ ANSI_BLACK;
		return ANSI_RED + firstL + " does not IMPLEMENTS " + secondL.get(0)
				+ ANSI_BLACK;
	}

	@Command
	public String implement() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		String featureName = null;
		System.out.println("Select Components in Implementation(Yy/Nn):");
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(
					System.in));
			Iterator<Map.Entry<String, String>> entries = reasoner
					.getComponentsMap().entrySet().iterator();
			while (entries.hasNext()) {
				Map.Entry<String, String> entry = entries.next();
				System.out.print(entry.getKey() + " :");
				String ch = null;

				ch = br.readLine();

				if (ch != null && (ch.equals("Y") || ch.equals("y")))
					firstL.add(entry.getKey());
			}
			System.out.print("Enter Feature :");
			featureName = br.readLine();
			while (featureName == null
					|| (featureName != null && "".equals(featureName.trim())))
				featureName = br.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		boolean found = validInput(featureName, reasoner.getFeaturesMap());
		if (!found)
			return ANSI_RED + "Invalid element: " + featureName
					+ "\nInput is case sensitive.\n" + ANSI_BLACK;
		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		QSATResult ask = (QSATResult) reasoner.ask(q);
		if (!ask.isResultFlag())
			return ANSI_RED + firstL + "\nThe Implementation is NOT VALID.\n"
					+ ANSI_BLACK;
		ImplementsQuestion iq = new ImplementsQuestion(firstL, featureName);
		long startTime = System.currentTimeMillis();
		ask = (QSATResult) reasoner.ask(iq);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + firstL + " IMPLEMENTS " + featureName
					+ ANSI_BLACK;
		return ANSI_RED + firstL + " does not IMPLEMENTS " + featureName
				+ ANSI_BLACK;
	}

	@Command
	public String realizes(
			@Param(name = "numbers", description = "add the implementation, a comma and the specifications") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		List<String> secondL = new ArrayList<String>();

		boolean first = true;
		for (String str : input) {
			if (first) {
				if (str.equals(",")) {
					first = false;
				} else {
					boolean found = validInput(str, reasoner.getComponentsMap());
					if (!found)
						return ANSI_RED + "Invalid element: " + str
								+ "\nInput is case sensitive.\n" + ANSI_BLACK;
					firstL.add(str);
				}
			} else {
				boolean found = validInput(str, reasoner.getFeaturesMap());
				if (!found)
					return ANSI_RED + "Invalid element: " + str
							+ "\nInput is case sensitive.\n" + ANSI_BLACK;
				secondL.add(str);
			}
		}

		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		QSATResult ask = (QSATResult) reasoner.ask(q);
		if (!ask.isResultFlag())
			return ANSI_RED + firstL + ":The Implementation is NOT VALID.\n"
					+ ANSI_BLACK;

		ValidSpecificationQuestion sq = new ValidSpecificationQuestion(secondL);
		ask = (QSATResult) reasoner.ask(sq);
		if (!ask.isResultFlag())
			return ANSI_RED + secondL + ":The Specification is NOT VALID.\n"
					+ ANSI_BLACK;

		RealizesQuestion rq = new RealizesQuestion(firstL, secondL);
		long startTime = System.currentTimeMillis();
		ask = (QSATResult) reasoner.ask(rq);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + firstL + " REALIZES the specification "
					+ secondL + ANSI_BLACK;
		return ANSI_RED + firstL + " does not REALIZES the specification "
				+ secondL + ANSI_BLACK;
	}

	@Command
	public String covers(
			@Param(name = "numbers", description = "add the implications, a comma and the specifications") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		List<String> secondL = new ArrayList<String>();

		boolean first = true;
		for (String str : input) {
			if (first) {
				if (str.equals(",")) {
					first = false;
				} else {
					boolean found = validInput(str, reasoner.getComponentsMap());
					if (!found)
						return ANSI_RED + "Invalid element: " + str
								+ "\nInput is case sensitive.\n" + ANSI_BLACK;
					firstL.add(str);
				}
			} else {
				boolean found = validInput(str, reasoner.getFeaturesMap());
				if (!found)
					return ANSI_RED + "Invalid element: " + str
							+ "\nInput is case sensitive.\n" + ANSI_BLACK;
				secondL.add(str);
			}
		}
		ValidImplementationQuestion q = new ValidImplementationQuestion(firstL);
		QSATResult ask = (QSATResult) reasoner.ask(q);
		if (!ask.isResultFlag())
			return ANSI_RED + firstL + ":The Implementation is NOT VALID.\n"
					+ ANSI_BLACK;

		ValidSpecificationQuestion sq = new ValidSpecificationQuestion(secondL);
		ask = (QSATResult) reasoner.ask(sq);
		if (!ask.isResultFlag())
			return ANSI_RED + secondL + ":The Specification is NOT VALID.\n"
					+ ANSI_BLACK;

		CoversQuestion cq = new CoversQuestion(firstL, secondL);
		long startTime = System.currentTimeMillis();
		ask = (QSATResult) reasoner.ask(cq);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + firstL + " COVERS the specification " + secondL
					+ ANSI_BLACK;
		return ANSI_RED + firstL + " does not COVERS the specification "
				+ secondL + ANSI_BLACK;

	}

	@Command
	public String completness() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		CompletenessQuestion q = new CompletenessQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "SPL hold COMPLETNESS Property.\n" + ANSI_BLACK;
		return ANSI_RED + "SPL does not hold COMPLETNESS Property.\n"
				+ ANSI_BLACK;
	}

	@Command
	public String soundness() {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		SoundnessQuestion q = new SoundnessQuestion();
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "SPL hold SOUNDNESS Property.\n" + ANSI_BLACK;
		return ANSI_RED + "SPL does not hold SOUNDNESS Property.\n"
				+ ANSI_BLACK;
	}

	@Command
	public String common(String name) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		boolean found = validInput(name, reasoner.getFeaturesMap());
		if (!found) {
			found = validInput(name, reasoner.getComponentsMap());
		}
		if (!found)
			return ANSI_RED+"Invalid element: " + name + "\nInput is case sensitive.\n"+ANSI_BLACK;
		CommonQuestion q = new CommonQuestion(name);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "\"" + name + "\""
					+ " is COMMON in all the products.\n" + ANSI_BLACK;
		return ANSI_RED + "\"" + name + "\""
				+ " is not COMMON in all the products.\n" + ANSI_BLACK;

	}

	@Command
	public String live(String name) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		boolean found = validInput(name, reasoner.getFeaturesMap());
		if (!found) {
			found = validInput(name, reasoner.getComponentsMap());
		}
		if (!found)
			return ANSI_RED+"Invalid element: " + name + "\nInput is case sensitive.\n"+ANSI_BLACK;
		LiveQuestion q = new LiveQuestion(name);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "\"" + name + "\"" + " is LIVE in SPL.\n"
					+ ANSI_BLACK;
		return ANSI_RED + "\"" + name + "\"" + " is not LIVE in SPL.\n"
				+ ANSI_BLACK;
	}

	@Command
	public String dead(String name) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		boolean found = validInput(name, reasoner.getFeaturesMap());
		if (!found) {
			found = validInput(name, reasoner.getComponentsMap());
		}
		if (!found)
			return ANSI_RED+"Invalid element: " + name + "\nInput is case sensitive.\n"+ANSI_BLACK;
		DeadQuestion q = new DeadQuestion(name);
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_RED + "\"" + name + "\"" + " is DEAD in SPL.\n"
					+ ANSI_BLACK;
		return ANSI_GREEN + "\"" + name + "\"" + " is not DEAD in SPL.\n"
				+ ANSI_BLACK;
	}

	@Command
	public String critical(String feature, String critical) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);

		boolean found = validInput(feature, reasoner.getFeaturesMap());
		if (!found)
			return ANSI_RED+"Invalid element: " + feature + "\nInput is case sensitive.\n"+ANSI_BLACK;
		found = validInput(critical, reasoner.getComponentsMap());
		if (!found)
			return ANSI_RED+"Invalid element: " + critical + "\nInput is case sensitive.\n"+ANSI_BLACK;
		CriticalQuestion cq = new CriticalQuestion(feature, critical);
		long startTime = System.currentTimeMillis();
		QSATResult ask1 = (QSATResult) reasoner.ask(cq);
		NotCriticalQuestion nq = new NotCriticalQuestion(feature, critical);
		QSATResult ask2 = (QSATResult) reasoner.ask(nq);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask1.isResultFlag() && !ask2.isResultFlag())
			return ANSI_GREEN + "\"" + critical + "\""
					+ " is CRITICAL for feature \"" + feature + "\".\n"
					+ ANSI_BLACK;
		return ANSI_RED + "\"" + critical + "\""
					+ " is NOT CRITICAL for feature \"" + feature + "\".\n"
					+ ANSI_BLACK;
	}

	@Command
	public String union(
			@Param(name = "numbers", description = "(S(spec),I(imp),P(product)) add the List one, a comma and the list two.") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		List<String> secondL = new ArrayList<String>();
		boolean first = true;
		for (String str : input) {
			if (first) {
				if (str.equals(",")) {
					first = false;
				} else {
					firstL.add(str);
				}
			} else {
				secondL.add(str);
			}
		}
		UnionQuestion q = new UnionQuestion(firstL.subList(1, firstL.size()),
				secondL, firstL.get(0));
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "UNION is possible.\n" + ANSI_BLACK;
		return ANSI_RED + "UNION is not possible.\n" + ANSI_BLACK;
	}

	@Command
	public String intersection(
			@Param(name = "numbers", description = "(S(spec),I(imp),P(product)) add the List one, a comma and the list two.") String... input) {
		SplaneModelTransform t = new SplaneModelTransform();
		QSATReasoner reasoner = new QSATReasoner();
		t.transform(featuremod, componentmod, tracemod, reasoner);
		List<String> firstL = new ArrayList<String>();
		List<String> secondL = new ArrayList<String>();
		boolean first = true;
		for (String str : input) {
			if (first) {
				if (str.equals(",")) {
					first = false;
				} else {
					firstL.add(str);
				}
			} else {
				secondL.add(str);
			}
		}
		IntersectionQuestion q = new IntersectionQuestion(firstL.subList(1,
				firstL.size()), secondL, firstL.get(0));
		long startTime = System.currentTimeMillis();
		QSATResult ask = (QSATResult) reasoner.ask(q);
		long stopTime = System.currentTimeMillis();
		System.out.println("Execution Time(ms):" + (stopTime - startTime));
		if (ask.isResultFlag())
			return ANSI_GREEN + "INTERSECTION is possible.\n" + ANSI_BLACK;
		return ANSI_RED + "INTERSECTION is not possible.\n" + ANSI_BLACK;
	}

	public static void main(String[] args) throws IOException {
		ShellFactory.createConsoleShell("splane", "", new mainShell())
				.commandLoop(); // and three.
	}

	private boolean validInput(String name, Map<String, String> map) {
		Iterator<Map.Entry<String, String>> entries = map.entrySet().iterator();
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = entries.next();
			if (name != null && name.equals(entry.getKey())) {
				return true;
			}
		}
		return false;
	}

}
