import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import es.us.isa.FAMA.models.featureModel.GenericFeature;
import es.us.isa.FAMA.models.variabilityModel.VariabilityElement;
import es.us.isa.FAMA.models.variabilityModel.VariabilityModel;
import es.us.isa.Sat4jReasoner.Sat4jReasoner;
import es.us.isa.Sat4jReasoner.questions.Sat4jCommonQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jCoversQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jCriticalQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jDeadQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jImplementationQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jIntersectionQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jLiveQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jProductsQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidModelQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jVoidProductModelQuestion;

public class MySat4jThread implements Runnable {
	private String op;
	private int nof;
	private int nctc;
	private int i;
	private Sat4jReasoner reasoner;
	private VariabilityModel fm;
	private VariabilityModel comp;
    PrintWriter out ;

	MySat4jThread(String op, int nof, int nctc, int i, Sat4jReasoner reasoner,
			VariabilityModel fm,VariabilityModel comp,PrintWriter out) throws IOException {
		this.op = op;
		this.nctc=nctc;
		this.nof = nof;
		this.i = i;
		this.reasoner = reasoner;
		this.fm = fm;
		this.comp=comp;
		this.out = out;
	}

	@Override
	public void run() {
		Random r = new Random();
		Collection<? extends VariabilityElement> elements = fm.getElements();
		Object[] array = elements.toArray();
		String featurea = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();
		String featureb = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();
		String featurec = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();

		List<String> colfm = new LinkedList<String>();
		colfm.add(featurea);
		colfm.add(featureb);
		colfm.add(featurec);

		Collection<? extends VariabilityElement> comelements = comp.getElements();
		Object[] comparray = comelements.toArray();
		String compa = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();
		String compb = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();
		String compc = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();

		List<String> colcomp = new LinkedList<String>();
		colcomp.add(compa);
		colcomp.add(compb);
		colcomp.add(compc);
		long time=0;
		if (op.equals("DEAD")) {
			time = this.dead(featurea);
		} else if (op.equals("LIVE")) {
			time = this.live(featurea);
		} else if (op.equals("SOUNDNESS")) {
			time = this.soundness();
		} else if (op.equals("COMPLETENESS")) {
			time = this.completeness();
		} else if (op.equals("COMMON")) {
			time = this.Common(featurea);
		} else if (op.equals("NOTCRITICAL")) {
			time = this.notCritical(colcomp,featurea, compa);
		} else if (op.equals("INTERSECTION")) {
			time = this.intersection(colfm, colcomp);
		} else if (op.equals("IMPLEMENTS")) {
			time = this.implementsQ(featurea, colcomp);
		} else if (op.equals("EXISTENTIALLY")) {
			time = this.existentially(colfm);
		} else if (op.equals("CRITICAL")) {
			time = this.critical(colcomp,featurea, compa);
		} else if (op.equals("COVERS")) {
			time = this.covers(colfm, colfm);
		} else if (op.equals("VALIDP")) {
			time = this.validpmodel();
		} else if (op.equals("VALID")) {
			time = this.valid();
		}
		out.append("Sat4j;"+op+";"+nof+";"+nctc+";"+i+";"+time+"\r\n");
		System.out.println("Sat4j;"+op+";"+nof+";"+nctc+";"+i+";"+time);
		out.flush();
		
	}

	private long dead(String featurea) {
		Sat4jDeadQuestion q4 = new Sat4jDeadQuestion(featurea);
		//q4.prepath=nof+"-"+nctc+"-"+i;
		long start = System.currentTimeMillis();
		reasoner.ask(q4);
		return  System.currentTimeMillis()-start ;
	}

	private long live(String featurea) {
		Sat4jLiveQuestion q3 = new Sat4jLiveQuestion(featurea);
	//	q3.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q3);
		return  System.currentTimeMillis()-start ;
	}

	private long soundness() {
		Sat4jProductsQuestion q2 = new Sat4jProductsQuestion();
	//	q2.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q2);
		return  System.currentTimeMillis()-start ;
	}

	private long completeness() {
		Sat4jProductsQuestion q1 = new Sat4jProductsQuestion();
		//q1.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q1);
		return  System.currentTimeMillis()-start ;
	}

	private long Common(String featurea) {
		Sat4jCommonQuestion q = new Sat4jCommonQuestion(featurea);
		//q.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q);
		return  System.currentTimeMillis()-start ;
	}

	private long notCritical(Collection<String> compcol,String featurea, String compa) {

		Sat4jCriticalQuestion qt = new Sat4jCriticalQuestion(compcol,featurea, compa);
	//	qt.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qt);
		return  System.currentTimeMillis()-start ;
	}

	private long intersection(List<String> colfm, List<String> colcomp) {
		Sat4jIntersectionQuestion qy = new Sat4jIntersectionQuestion(colfm, colcomp,
				QBFFormulaConstants.INPUT_TYPE_PRODUCT);
	//	qy.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qy);
		return  System.currentTimeMillis()-start ;
	}

	private long implementsQ(String compa, Collection<String> colcomp) {
		Sat4jImplementationQuestion qu = new Sat4jImplementationQuestion(colcomp, compa);
		long start = System.currentTimeMillis();
		
		reasoner.ask(qu);
		return  System.currentTimeMillis()-start ;
	}

	private long existentially(List<String> colfm) {
		HashMap<String, Boolean> input = new HashMap<String, Boolean>();
		for (String s : colfm) {
			input.put(s, true);
		}
		//Sat4jExistentiallyExplicitQuestion qi = new Sat4jExistentiallyExplicitQuestion(input);
	//	qi.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();

	//	reasoner.ask(qi);
		return  System.currentTimeMillis()-start ;
	}

	private long critical(List<String> colcomp, String featurea, String compa) {
		Sat4jCriticalQuestion qo = new Sat4jCriticalQuestion(colcomp,featurea, compa);
		//qo.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qo);
		return  System.currentTimeMillis()-start ;
	}

	private long covers(List<String> colfm, List<String> colcomp) {
		Sat4jCoversQuestion qp = new Sat4jCoversQuestion(colcomp, colfm);
		//qp.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qp);
		return  System.currentTimeMillis()-start ;
	}

	private long validpmodel() {
		Sat4jVoidProductModelQuestion qa = new Sat4jVoidProductModelQuestion();
	//	qa.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qa);
		return  System.currentTimeMillis()-start ;
	}

	private long valid() {
		Sat4jValidModelQuestion qb = new Sat4jValidModelQuestion();
	//	qb.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qb);
		return  System.currentTimeMillis()-start ;
	}
}
