import in.barc.iitb.cfdvs.QSATConstants.QBFFormulaConstants;
import in.barc.iitb.cfdvs.QSATReasoner.QSATReasoner;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CommonQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CompletenessQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CoversQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.CriticalQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.DeadQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ExistentiallyExplicitQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ImplementsQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.IntersectionQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.LiveQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.NotCriticalQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.SoundnessQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.ValidModelQuestion;
import in.barc.iitb.cfdvs.QSATReasoner.questions.VoidProductModelQuestion;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import es.us.isa.FAMA.models.featureModel.GenericFeature;
import es.us.isa.FAMA.models.variabilityModel.VariabilityElement;
import es.us.isa.FAMA.models.variabilityModel.VariabilityModel;

public class MyThread implements Runnable {
	private String op;
	private int nof;
	private int nctc;
	private int i;
	private QSATReasoner reasoner;
	private VariabilityModel fm;
	private VariabilityModel comp;
    PrintWriter out ;

	MyThread(String op, int nof, int nctc, int i, QSATReasoner reasoner,
			VariabilityModel fm,VariabilityModel comp,PrintWriter out) throws IOException {
		this.op = op;
		this.nctc=nctc;
		this.nof = nof;
		this.i = i;
		this.reasoner = reasoner;
		this.fm = fm;
		this.comp=comp;
		this.out = out;
	}

	@Override
	public void run() {
		Random r = new Random();
		Collection<? extends VariabilityElement> elements = fm.getElements();
		Object[] array = elements.toArray();
		String featurea = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();
		String featureb = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();
		String featurec = ((GenericFeature) array[r.nextInt(array.length)])
				.toString();

		List<String> colfm = new LinkedList<String>();
		colfm.add(featurea);
		colfm.add(featureb);
		colfm.add(featurec);

		Collection<? extends VariabilityElement> comelements = comp.getElements();
		Object[] comparray = comelements.toArray();
		String compa = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();
		String compb = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();
		String compc = ((GenericFeature) comparray[r.nextInt(comparray.length)])
				.toString();

		List<String> colcomp = new LinkedList<String>();
		colcomp.add(compa);
		colcomp.add(compb);
		colcomp.add(compc);
		long time=0;
		if (op.equals("DEAD")) {
			time = this.dead(featurea);
		} else if (op.equals("LIVE")) {
			time = this.live(featurea);
		} else if (op.equals("SOUNDNESS")) {
			time = this.soundness();
		} else if (op.equals("COMPLETENESS")) {
			time = this.completeness();
		} else if (op.equals("COMMON")) {
			time = this.Common(featurea);
		} else if (op.equals("NOTCRITICAL")) {
			time = this.notCritical(featurea, compa);
		} else if (op.equals("INTERSECTION")) {
			time = this.intersection(colfm, colcomp);
		} else if (op.equals("IMPLEMENTS")) {
			time = this.implementsQ(featurea, colcomp);
		} else if (op.equals("EXISTENTIALLY")) {
			time = this.existentially(colfm);
		} else if (op.equals("CRITICAL")) {
			time = this.critical(featurea, compa);
		} else if (op.equals("COVERS")) {
			time = this.covers(colfm, colfm);
		} else if (op.equals("VALIDP")) {
			time = this.validpmodel();
		} else if (op.equals("VALID")) {
			time = this.valid();
		}
		out.append("QSat;"+op+";"+nof+";"+nctc+";"+i+";"+time+"\r\n");
		System.out.println("QSat;"+op+";"+nof+";"+nctc+";"+i+";"+time);
		out.flush();
		
	}

	private long dead(String featurea) {
		DeadQuestion q4 = new DeadQuestion(featurea);
		q4.prepath=nof+"-"+nctc+"-"+i;
		long start = System.currentTimeMillis();
		reasoner.ask(q4);
		return  System.currentTimeMillis()-start ;
	}

	private long live(String featurea) {
		LiveQuestion q3 = new LiveQuestion(featurea);
		q3.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q3);
		return  System.currentTimeMillis()-start ;
	}

	private long soundness() {
		SoundnessQuestion q2 = new SoundnessQuestion();
		q2.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q2);
		return  System.currentTimeMillis()-start ;
	}

	private long completeness() {
		CompletenessQuestion q1 = new CompletenessQuestion();
		q1.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q1);
		return  System.currentTimeMillis()-start ;
	}

	private long Common(String featurea) {
		CommonQuestion q = new CommonQuestion(featurea);
		q.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(q);
		return  System.currentTimeMillis()-start ;
	}

	private long notCritical(String featurea, String compa) {

		NotCriticalQuestion qt = new NotCriticalQuestion(featurea, compa);
		qt.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qt);
		return  System.currentTimeMillis()-start ;
	}

	private long intersection(List<String> colfm, List<String> colcomp) {
		IntersectionQuestion qy = new IntersectionQuestion(colfm, colcomp,
				QBFFormulaConstants.INPUT_TYPE_PRODUCT);
		qy.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qy);
		return  System.currentTimeMillis()-start ;
	}

	private long implementsQ(String compa, List<String> colcomp) {
		ImplementsQuestion qu = new ImplementsQuestion(colcomp, compa);
		long start = System.currentTimeMillis();
		qu.prepath=nof+"-"+nctc+"-"+i;

		reasoner.ask(qu);
		return  System.currentTimeMillis()-start ;
	}

	private long existentially(List<String> colfm) {
		HashMap<String, Boolean> input = new HashMap<String, Boolean>();
		for (String s : colfm) {
			input.put(s, true);
		}
		ExistentiallyExplicitQuestion qi = new ExistentiallyExplicitQuestion(
				input);
		qi.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();

		reasoner.ask(qi);
		return  System.currentTimeMillis()-start ;
	}

	private long critical(String featurea, String compa) {
		CriticalQuestion qo = new CriticalQuestion(featurea, compa);
		qo.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qo);
		return  System.currentTimeMillis()-start ;
	}

	private long covers(List<String> colfm, List<String> colcomp) {
		CoversQuestion qp = new CoversQuestion(colcomp, colfm);
		qp.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qp);
		return  System.currentTimeMillis()-start ;
	}

	private long validpmodel() {
		VoidProductModelQuestion qa = new VoidProductModelQuestion();
		qa.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qa);
		return  System.currentTimeMillis()-start ;
	}

	private long valid() {
		ValidModelQuestion qb = new ValidModelQuestion();
		qb.prepath=nof+"-"+nctc+"-"+i;

		long start = System.currentTimeMillis();
		reasoner.ask(qb);
		return  System.currentTimeMillis()-start ;
	}
}
