import in.barc.iitb.cfdvs.SPLANE.models.parser.TraceabilityParser;
import in.barc.iitb.cfdvs.SPLANEModel.transformations.SplaneModelTransform;

import java.io.IOException;

import es.us.isa.FAMA.models.FAMAfeatureModel.fileformats.XMLReader;
import es.us.isa.FAMA.models.variabilityModel.TraceabilityModel;
import es.us.isa.FAMA.models.variabilityModel.VariabilityModel;
import es.us.isa.FAMA.models.variabilityModel.parsers.WrongFormatException;
import es.us.isa.Sat4jReasoner.Sat4jReasoner;
import es.us.isa.Sat4jReasoner.questions.Sat4jCommonQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jCoversQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jCriticalQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jDeadQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jImplementationQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jIntersectionQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jLiveQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jProductsQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jRealizesQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jUnionQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidComponentModelQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidFeatureModelQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidImplementationQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidModelQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jValidSpecificationQuestion;
import es.us.isa.Sat4jReasoner.questions.Sat4jVoidProductModelQuestion;


public class sat4jtest {

	public static void main(String[] args) throws IOException, InterruptedException, WrongFormatException {
		XMLReader reader = new XMLReader();
		VariabilityModel fm = reader.parseFile("./models/10-15-0.fm");
		VariabilityModel cm = reader.parseFile("./models/10-15-0.cfm");		
		
		SplaneModelTransform transform = new SplaneModelTransform();
		Sat4jReasoner reasoner = new Sat4jReasoner();
		
		TraceabilityParser trace = new TraceabilityParser("./models/10-15-0.tfm");
		trace.parse();
		TraceabilityModel traceModel = new TraceabilityModel();
		traceModel.setTraceabilityOrgMap(trace.getTraProvidesMap());
		transform.transform(fm, cm, traceModel, reasoner);
		
		/*
		System.out.println("------------------------------");
		System.out.println("variables:"+reasoner.getVariables());
		System.out.println("traceability:"+reasoner.getTraceability());
		System.out.println("traceFormula:"+reasoner.getTraceFormula());
		System.out.println("cnf_content:"+reasoner.getCNFContent());
		System.out.println("featureMap:"+reasoner.getFeaturesMap());
		System.out.println("clauses:"+reasoner.getClauses());
		System.out.println("clausesFeatures:"+reasoner.getClausesFeatures());
		System.out.println("clausesComponents:"+reasoner.getClausesComponets());
		System.out.println("numvar:"+reasoner.getnumVar());
		System.out.println("addedClauses:"+reasoner.getAddedClauses());
		System.out.println("out");
		*/
		
		/*-----------------Valid FM Question -----------------*/
		Sat4jValidFeatureModelQuestion validFMModel = new Sat4jValidFeatureModelQuestion();
		reasoner.ask(validFMModel);
		System.out.println(validFMModel.toString());
		
		
		/*-----------------Valid CM Question -----------------*/
		Sat4jValidComponentModelQuestion validCMModel = new Sat4jValidComponentModelQuestion();
		reasoner.ask(validCMModel);
		System.out.println(validCMModel.toString());
		
		/*-----------------Valid Model Question -----------------*/
		Sat4jValidModelQuestion validModel = new Sat4jValidModelQuestion();
		reasoner.ask(validModel);
		System.out.println(validModel.toString());
		
		
		/*-----------------Void Product Question -----------------*/
		Sat4jVoidProductModelQuestion voidProductModelQuestion = new Sat4jVoidProductModelQuestion();
		reasoner.ask(voidProductModelQuestion);
		System.out.println(voidProductModelQuestion.toString());
		
		
		/*-----------------Valid Specification Question -----------------*/
		Sat4jValidSpecificationQuestion validSpecificationQuestion = new Sat4jValidSpecificationQuestion();
		reasoner.ask(validSpecificationQuestion);
		System.out.println(validSpecificationQuestion.toString());
		
		
		/*-----------------Valid Implementation Question -----------------*/
		Sat4jValidImplementationQuestion validImplementationQuestion = new Sat4jValidImplementationQuestion();
		reasoner.ask(validImplementationQuestion);
		System.out.println(validImplementationQuestion.toString());
		
		/*----------------- Implementation Question -----------------*/
		Sat4jImplementationQuestion implementationQuestion = new Sat4jImplementationQuestion();
		reasoner.ask(implementationQuestion);
		System.out.println(implementationQuestion.toString());
		
		/*----------------- Covers Question -----------------*/
		Sat4jCoversQuestion coversQuestion = new Sat4jCoversQuestion();
		reasoner.ask(coversQuestion);
		System.out.println(coversQuestion.toString());
		
		
		/*----------------- Realizes Question -----------------*/
		Sat4jRealizesQuestion realizesQuestion = new Sat4jRealizesQuestion();
		reasoner.ask(realizesQuestion);
		System.out.println(realizesQuestion.toString());
		
		/*----------------- Union Question -----------------*/
		Sat4jUnionQuestion unionQuestion = new Sat4jUnionQuestion();
		reasoner.ask(unionQuestion);
		System.out.println(unionQuestion.toString());
		
		/*----------------- Intersection Question -----------------*/
		Sat4jIntersectionQuestion intersectionQuestion = new Sat4jIntersectionQuestion();
		reasoner.ask(intersectionQuestion);
		System.out.println(intersectionQuestion.toString());
		
		
		/*----------------- Common Question -----------------*/
		Sat4jCommonQuestion commonQuestion = new Sat4jCommonQuestion();
		reasoner.ask(commonQuestion);
		System.out.println(commonQuestion.toString());
		
		
		/*----------------- Live Question -----------------*/
		Sat4jLiveQuestion liveQuestion = new Sat4jLiveQuestion();
		reasoner.ask(liveQuestion);
		System.out.println(liveQuestion.toString());
		
		/*----------------- Dead Question -----------------*/
		Sat4jDeadQuestion deadQuestion = new Sat4jDeadQuestion();
		reasoner.ask(deadQuestion);
		System.out.println(deadQuestion.toString());
		
		/*----------------- Critical Question -----------------*/
		Sat4jCriticalQuestion criticalQuestion = new Sat4jCriticalQuestion();
		reasoner.ask(criticalQuestion);
		System.out.println(criticalQuestion.toString());
		
		Sat4jProductsQuestion completness = new Sat4jProductsQuestion();
		reasoner.ask(completness);
		/*
		Collection<Product> allProducts = completness.getAllProducts();
		for(Product p : allProducts){
			System.out.println(p);
		}*/
	}
	
}
